      COMPLEX FUNCTION ZCISP*16(AA,BB,Z)
C
C     THIS FUNCTION IS USED TO EVALUATE THE INDEFINITE INTEGRAL OF
C     Z*CDSIN(AA*Z)*CDSIN(BB*Z). 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 AA,BB,UP,UM,VP,VM,U,V
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      IF((CDABS(AA-BB)/FKB .LT. .5D-13) .OR.
     1   (CDABS(AA+BB)/FKB .LT. .5D-13))  GO TO 200
C
      UM=CDCOS((AA-BB)*Z)/(AA-BB)**2
      UP=CDCOS((AA+BB)*Z)/(AA+BB)**2
      VM=Z*CDSIN((AA-BB)*Z)/(AA-BB)
      VP=Z*CDSIN((AA+BB)*Z)/(AA+BB)
      ZCISP=.5*(UM+VM)-.5*(UP+VP)
      GO TO 300
C
  200 CONTINUE
      U=Z*CDSIN(2.0*AA*Z)/(4.0*AA)
      V=CDCOS(2.0*AA*Z)/(8.0*AA**2)
      ZCISP=(Z**2/4.0)-U-V
      IF(CDABS(AA+BB)/FKB .LT. .5D-13) ZCISP=-ZCISP
C
  300 CONTINUE
C
      RETURN
      END
